// 6.05.2007   
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//|                                                  BrainTrend1.mq4 |
//|                                          BrainTrend Black edition|
//|                                     http://www.braintrading.com  |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
#property copyright "BrainTrend Black edition "
#property link      "http://www.braintrading.com"


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue


//---- input parameters
extern int    Length    = 1;
extern int    Price     = 0;
extern double Phase     = 5;
extern int    f         = 7;
extern int    x1        = 53;
extern int    x2        = 47;
extern int    value11   = 9;

double Ind_Buffer1[];
double Ind_Buffer2[];


double value2;
double Range;
double val1;
double val2;
double val3;

int p = 0;
int d = 2.3;
 


//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator initialization function                         |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+


int init()
  {
   string short_name;
   SetIndexBuffer(0,Ind_Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,""+short_name+"_Down");
   SetIndexBuffer(1,Ind_Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,""+short_name+"_Up"  );   
   
   short_name="BrainTrend1";
   IndicatorShortName(short_name);
   
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));

   return(0);
  }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator iteration function                              |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int start()
{
   double CloseVal, CloseVal2, HighVal, LowVal;
   Comment("BrainTrading Inc. System 7.0");
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
       for(i=limit; i>=0; i--)
       { 
       Range  = iATR(NULL,0,f,i)/d;
       value2 = iStochastic(NULL,0,value11,value11,1,0,0,0,i);
       val1   = 0.0;
       val2   = 0.0;
      
       CloseVal  = NormalizeDouble(iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i  ),Length,Phase,i,   0),Digits);
       CloseVal2 = NormalizeDouble(iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i+2),Length,Phase,i+2,10),Digits);
      
       HighVal = NormalizeDouble(iSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i),Length,Phase,i,20),Digits);
       LowVal  = NormalizeDouble(iSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW, i),Length,Phase,i,30),Digits);
       val3 = MathAbs(CloseVal - CloseVal2);
       if (value2 < x2 && val3 > Range) p = 1;
       if (value2 > x1 && val3 > Range) p = 2;
       if (value2 < x2 && (p == 1||p == 0))
         {
         if ( val3 > Range)
            {
            val1 = HighVal;
            val2 = LowVal;
            }
         }
      if (value2 > x1 && (p == 2||p == 0))
         {
         val2 = HighVal;
         val1 = LowVal;
         }
      Ind_Buffer1[i]=val1;
      Ind_Buffer2[i]=val2;
     
      } 
   return(0);
  }
  
    
double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

  
double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
/*
Here is my BT strategy. I've been using this strategy for about 6 months now and have been achieving very high results with it, aroung 40 to 100 pips a day. OK, here it is: 

Timeframe: 1hour works best, but could use on 30 min. 
Indicators: 
Braintrend 1, Signal1, Stop1, and Stopline1, Signal Close Alert 1 
t3 Aroon Horn Smoothed 
t3 Aroon Horn Oscillator: line drawn at zero 
Trend Trigger Modifed version 3 (changed parameters to 50 and -50, instead of 100 and -100) 

Entry Long Signal: 
1. Blue bar completed with Braintrend signal dot (alert will sound and tell you the entry with stop placement). Do not enter yet. 
2. Aroon Horn Smoothed lines will cross each other. Do not enter yet. 
3. Trend Trigger will cross above the +50 line (must be crossing or already above +50 line to signal safe entry). Do not enter yet. 
4. We enter only when the Aroon Horn Oscillator crosses up over the zero line. (only if all of the other indicators agree) 

Entry Short Signal: 
Opposite above. 

Waiting until the Aroon Horn Oscillator crosses the zero line will ensure that the trend is in strength. It also coordinates quite often with the minor retracement that happens after the initial price move. The Aroon Horn Smoothed indicator is an early signal but a retracement could happen that is why we wait for the Oscillator to signal. 

I use to just jump right in when I first started using BT to try and get every pip but soon realized that there were many false signals given and one could have many whipsaws along the way. Using this strategy will eliminate many of those whipsaws and allow one to pull the trigger more confidently. 

Important note on the Trend Trigger, there has been some discussion about it curve fitting past results to fit ideal parameters. That is why I say wait until the Aroon Horn Oscillator crosses zero to verify the established trend. The market is range bound when between the +50 and -50. 

Note* One thing I've noticed, you can use the Trendsignal indicator (found elsewhere on this forum) as well to signal for entry but only if the other rules are followed. 

I hope this helps some of you who are hesitant to pull that trigger when a trade happens. Please let me know what you think and if this can be improved. I've attached some of the required indicators (minus Braintrader) here. Enjoy. 

Let's all share the knowledge. 

  :  4     ,   -   .

     .         ,   4 .     ,  (    =) ),            ...  ....
*/